// ===========================================================================
// SHA-256
// 2008.03.23 {@G 
// ===========================================================================

#include <stdio.h>

#define SHR(n, x) ( (x)>>(n) )
#define ROTR(n, x) ( ( (x)>>(n) ) | ( (x)<<(32-n) ) )

#define Ch(x,y,z)  ( ( (x) & (y) ) ^ ( ~(x) & (z) ) )
#define Maj(x,y,z) ( ( (x) & (y) ) ^ (  (x) & (z) ) ^ ( (y) & (z) ) )

#define S256_0(x) ( ROTR( 2 , x) ^ ROTR(13 , x) ^ ROTR(22, x) )
#define S256_1(x) ( ROTR( 6 , x) ^ ROTR(11 , x) ^ ROTR(25, x) )
 
#define s256_0(x) ( ROTR( 7 , x) ^ ROTR(18 , x) ^ SHR( 3 , x) )
#define s256_1(x) ( ROTR(17 , x) ^ ROTR(19 , x) ^ SHR(10 , x) )


void SHA256_transform(unsigned long H[],unsigned long W[])
{
    static const unsigned long K[64]=
    {
    0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
    0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
    0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
    0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
    0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
    0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
    0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
    0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
    0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
    0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
    0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
    0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
    0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
    0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
    0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
    0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
    };

    unsigned long T1, T2;
    unsigned long x[8];
    int t;
    memcpy(x, H, 32);
#define ROUND(n,a,b,c,d,e,f,g,h)\
        T1=x[h]+S256_1(x[e])+Ch(x[e],x[f],x[g])+K[t+n]+W[t+n];\
        T2=S256_0(x[a])+Maj(x[a],x[b],x[c]);\
        x[d]=x[d]+T1;\
        x[h]=T1+T2

    for(t=0; t<64; t+=8){
        ROUND(0,0,1,2,3,4,5,6,7);
        ROUND(1,7,0,1,2,3,4,5,6);
        ROUND(2,6,7,0,1,2,3,4,5);
        ROUND(3,5,6,7,0,1,2,3,4);
        ROUND(4,4,5,6,7,0,1,2,3);
        ROUND(5,3,4,5,6,7,0,1,2);
        ROUND(6,2,3,4,5,6,7,0,1);
        ROUND(7,1,2,3,4,5,6,7,0);
    }
    H[0]+=x[0];
    H[1]+=x[1];
    H[2]+=x[2];
    H[3]+=x[3];
    H[4]+=x[4];
    H[5]+=x[5];
    H[6]+=x[6];
    H[7]+=x[7];
}


void SHA256_process(unsigned long H[],unsigned long W[])
{
    int t;
    for (t=0 ;t<16 ;t++) //little-endianbig-endianɕϊ@big-endian̋@ł͕sv
        W[t]=W[t]<<24 | W[t]<<8 & 0xFF0000 | W[t]>>8 & 0xFF00 | W[t]>>24;
    for (t=16 ;t<64 ; t++) W[t] = s256_1(W[t-2]) + W[t-7] + s256_0(W[t-15]) + W[t-16];
    SHA256_transform(H,W);
}


//ćA64oCg菭ȂoCg̏AI  
void SHA256_finish(unsigned long H[],unsigned long W[],unsigned long long FileLen)
{
    int t;
    int Witi=(FileLen%64)/4;
    int amari=(FileLen%4)*8; //32rbg̃f[^̂Ȃ]rbg 
    for (t=0 ;t<=Witi ;t++) //little-endianbig-endianɕϊ@big-endian̋@ł͕sv
        W[t]=W[t]<<24 | W[t]<<8 & 0xFF0000 | W[t]>>8 & 0xFF00 | W[t]>>24;
    if (amari==0) W[Witi]=0x80000000; //bZ[W̏I1rbg𗧂Ă 
        else W[Witi]=W[Witi] & 0xFFFFFFFF<<(32-amari) | 0x80000000>>amari;
    Witi++;

    if(Witi>=15){  //Ōɓut@CvȂ̂ŁÃubN
        for (t=Witi; t<16 ; t++) W[t]=0;  //c̃ubN0Ŗ߂
        for (t=16 ; t<64 ; t++) W[t] = s256_1(W[t-2]) + W[t-7] + s256_0(W[t-15]) + W[t-16];
        SHA256_transform(H,W);
        Witi=0;
    }

    for(t=Witi;t<14; t++) W[t]=0; //c̃ubN0Ŗ߂
    W[14]=(unsigned long)(FileLen>>29); //ut@CṽoCgrbgɕϊē
    W[15]=(unsigned long)FileLen<<3;
    for (t=16 ; t<64 ; t++) W[t] = s256_1(W[t-2]) + W[t-7] + s256_0(W[t-15]) + W[t-16];
    SHA256_transform(H,W);
}


int SHA256(char *filename,unsigned long H[])
{
    H[0]=0x6a09e667;
    H[1]=0xbb67ae85;
    H[2]=0x3c6ef372;
    H[3]=0xa54ff53a;
    H[4]=0x510e527f;
    H[5]=0x9b05688c;
    H[6]=0x1f83d9ab;
    H[7]=0x5be0cd19;
    
    unsigned long W[64];
    FILE *fp;
    unsigned long Len;
    unsigned long long FileLen=0;//t@C

    if (!(fp=fopen(filename , "rb"))) return 1;
    while(1){
        Len=fread(W, 1, 64, fp);
        FileLen+=Len;
        if (Len!=64) break; 
        SHA256_process(H,W);
    }
    SHA256_finish(H,W,FileLen);
    if(ferror(fp)){//t@CG[ǂׂ
        fclose(fp);
        return 1;
    }
    fclose(fp);
    return 0;
}


int main(int argc, char**argv)
{
    unsigned long H[8]; //nbV
    int t;
    if (SHA256(argv[1],H)){  //argv[1]̓t@C̐擪̔Ԓn t@CH[8]߂B
        printf("t@CG[܂");
    }else{
        printf("%s\n\n",argv[1]);  //argv[1]̓t@C̐擪̔Ԓn
        for (t=0; t<8; t++) printf("%08x", H[t]);
    }
    printf("\n\n");
    system("PAUSE");
    return 0;
}
